Unit DE57R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTDE14_p;

procedure DE57R(FK :Func_F_DE; FG :Func_F_DE; FR :Func_F_DE; NX :Integer; XN :Real;
                XK :Real; GN1 :Boolean; var GN :Array of Real;
                GK1 :Boolean; var GK :Array of Real;
                var Y :Array of Real; var ALP :Array of Extended;
                var BET :Array of Extended; var IERR :Integer);

implementation

procedure DE57R(FK :Func_F_DE; FG :Func_F_DE; FR :Func_F_DE; NX :Integer; XN :Real;
                XK :Real; GN1 :Boolean; var GN :Array of Real;
                GK1 :Boolean; var GK :Array of Real;
                var Y :Array of Real; var ALP :Array of Extended;
                var BET :Array of Extended; var IERR :Integer);
var
I,NXM1,J :Integer;
XP,X :Real;
H,HP,H2,RA1,RA,RA2,Z :Extended;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15;
begin
IERR := 0;
if ( GN1 ) 
 then goto _1;
if ( GN[0] >= 0.0 ) 
 then goto _1;
IERR := 65;
goto _15;
_1:
if ( GK1 ) 
 then goto _2;
if ( GK[0] >= 0.0 ) 
 then goto _2;
IERR := 66;
goto _15;
_2:
if ( NX > 1 ) 
 then goto _3;
IERR := 69;
goto _15;
_3:
NXM1 := NX-1;
H := (XK-XN)/(NXM1);
if ( H <= 0.e0 ) 
 then goto _14;
HP := 0.5e0*H;
H2 := H*H;
XP := XN+HP;
X := XN;
RA1 := FK(XP);
if ( RA1 <= 0.e0 ) 
 then goto _12;
if ( GN1 ) 
 then goto _4;
RA := RA1/H;
RA2 := FG(X);
if ( RA2 < 0.e0 ) 
 then goto _13;
RA2 := RA+GN[0]+HP*RA2;
ALP[0] := RA/RA2;
BET[0] := (HP*FR(X)+GN[1])/RA2;
goto _5;
_4:
ALP[0] := 0.e0;
BET[0] := GN[0];
_5:
if ( NX = 2 ) 
 then goto _7;
for I:=2 to NXM1 do
 begin
  XP := XP+H;
  X := X+H;
  RA := RA1;
  RA1 := FK(XP);
  if ( RA1 <= 0.e0 ) 
   then goto _12;
  RA2 := FG(X);
  if ( RA2 < 0.e0 ) 
   then goto _13;
  RA2 := RA+RA1+H2*RA2-ALP[I-2]*RA;
  RA2 := 1.e0/RA2;
  ALP[I-1] := RA1*RA2;
  BET[I-1] := RA*BET[I-2]*RA2+H2*FR(X)*RA2;
_6:
 end;
_7:
if ( GK1 ) 
 then goto _8;
RA := RA1/H;
RA2 := FG(XK);
if ( RA2 < 0.e0 ) 
 then goto _13;
RA2 := RA+GK[0]+HP*RA2;
RA := RA/RA2;
RA1 := (HP*FR(XK)+GK[1])/RA2;
goto _9;
_8:
Y[NX-1] := GK[0];
Z := Y[NX-1];
goto _10;
_9:
Z := (RA1+RA*BET[NXM1-1])/(1.e0-ALP[NXM1-1]*RA);
Y[NX-1] := Z;
_10:
for I:=1 to NXM1 do
 begin
  J := NX-I;
  Z := ALP[J-1]*Z+BET[J-1];
  Y[J-1] := Z;
_11:
 end;
goto _15;
_12:
IERR := 67;
goto _15;
_13:
IERR := 68;
goto _15;
_14:
IERR := 70;
_15:
if ( IERR <> 0 ) 
 then UTDE14(IERR,57);
end;

end.
